import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Fish;

public class ShowCart extends HttpServlet {
  @Override
  protected void doPost(HttpServletRequest req, HttpServletResponse res) 
  throws ServletException, IOException {
    String account;
    
    HttpSession session = req.getSession(false);
    if(session==null || (account=(String)session.getAttribute("account"))==null) {
      res.sendRedirect(res.encodeRedirectURL("jsp/LoginFailed.jsp"));
    } else {
      HashMap<String, Fish> fish = (HashMap<String, Fish>)session.getAttribute("fish");  
      HashMap<String,Integer> cart = (HashMap<String, Integer>)session.getAttribute("cart");
      
      res.setContentType("text/html; charset=Windows-31J");
      PrintWriter out = res.getWriter();
      out.printf("<html><head><title>̊mF</title></head>%n");
      out.printf("<body><h1>̊mF</h1>%n");
      out.printf("<hr />%n");
      
      req.setCharacterEncoding("Windows-31J");  
      String added = req.getParameter("color");
      if(added!=null) {
        Fish f = fish.get(added);
        out.printf("<p>%s񂪑I%słB<img src='images/%s' /></p>%n<hr />%n",
            account, f.name, f.file);
        int total = (Integer)session.getAttribute("total");
        total += f.price;
        session.setAttribute("total", total);
        int n=0;
        try {
          n = cart.remove(added);   
        } catch (Exception e) {}
        cart.put(added, n+1);
      }
      out.printf("<p>܂%s񂪑I\܂B</p>%n", account);
      out.printf("<table border='2'>%n");
      out.printf("<tr><th>O</th><th>ʐ^</th><th>Rg</th><th>P</th><th>P</th><th></th><th>v</th></tr>%n");
      int total=0;
      for(String tmp : cart.keySet()) {
        Fish f = fish.get(tmp);
        int n = cart.get(tmp);
        out.printf("<tr><td>%s</td>", f.name); 
        out.printf("<td><img src='images/%s' alt='%s'></td>", f.file, f.file);
        out.printf("<td>%s</td>", f.comment);
        out.printf("<td>%s</td>", f.unit);
        out.printf("<td align='right'>%d~</td>", f.price);
        out.printf("<td align='right'>%d</td>", n);
        int subtotal = f.price*n;
        total += subtotal;
        out.printf("<td align='right'>%d~</td>", subtotal);
        out.printf("</tr>%n");
      }
      out.printf("<tr><td colspan='6' align='center'><b>v</b></td><td align='right'>%d~</td></tr>", total);
      out.printf("%n");
      out.printf("<ul>%n");
      out.printf("<li><a href='%s'>̑I</a>ɖ߂</li>%n", res.encodeURL("ItemList"));
      out.printf("<li><a href='%s'>OAEg</a></li>%n", res.encodeURL("Logout"));
      out.printf("<li><a href='%s'>w</a></li>%n", res.encodeURL("Payment"));
      out.printf("</ul>%n");
      out.printf("<hr /></body></html>%n");
    }
  }
  
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse res) 
  throws ServletException, IOException {
    doPost(req, res);
  }
}
