import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Fish;

public class ItemList extends HttpServlet {
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse res) 
  throws ServletException, IOException {
    String account;
    
    HttpSession session = req.getSession(false);
    if(session==null || (account=(String)session.getAttribute("account"))==null) {
      res.sendRedirect(res.encodeRedirectURL("jsp/LoginFailed.jsp"));
    } else {
      HashMap<String, Fish> fish = (HashMap<String, Fish>)session.getAttribute("fish"); 
      res.setContentType("text/html; charset=Windows-31J");
      
      PrintWriter out = res.getWriter();
      out.printf("<html><head><title>̑I</title></head>%n");
      out.printf("<body>%n");
      out.printf("<h1>̑I</h1>%n");
      out.printf("<p>%s悤I zMыVbv</p><hr />%n", account);
      out.printf("<ul>%n");
      out.printf("<li><a href='%s'>܂őI</a></li>%n", res.encodeURL("ShowCart"));
      out.printf("<li><a href='s'>OAEg</a></li>%n", res.encodeURL("Logout"));
      out.printf("</ul>%n");
      out.printf("<hr />%n");
      out.printf("<p><b></b>̎ʐ^ɂ́A쌠݂܂iԂjBJ̃y[Wł͎gpȂłB</p>");
      out.printf("<table border='2'>%n");
      
      out.printf("<tr><th>O</th><th>ʐ^</th><th>Rg</th><th>P</th><th>i</th><th>&nbsp;</th></tr>%n");
      for(String s : fish.keySet()) {
        Fish f = fish.get(s);
        out.printf("<tr><td>%s</td>", f.name); 
        out.printf("<td><img src='images/%s' alt='%s'></td>", f.file, f.file);
        out.printf("<td>%s</td>", f.comment);
        out.printf("<td>%s</td>", f.unit);
        out.printf("<td align='right'>%d~</td>", f.price);
        out.printf("<td><form action='%s' method='post'>", res.encodeURL("ShowCart"));
        out.printf("<input type='hidden' name='color' value='%s' />",s);
        out.printf("<input type='submit' value='I' />");
        out.printf("</form></td>");
        out.printf("</tr>%n");
      }
      out.printf("</table><hr />%n");
      out.printf("</body></html>%n");
    }
  }
  
}
